/*
Stats API Documentation

Official API for Major League Baseball.

API version: 2.0.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package api

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
)


// BroadcastAPIService BroadcastAPI service
type BroadcastAPIService service

type ApiGetAllBroadcastersRequest struct {
	ctx context.Context
	ApiService *BroadcastAPIService
	activeStatus *interface{}
	fields *interface{}
}

// Current status of the broadcaster. Format: Active &#x3D; y, inactive &#x3D; n, both &#x3D; b
func (r ApiGetAllBroadcastersRequest) ActiveStatus(activeStatus interface{}) ApiGetAllBroadcastersRequest {
	r.activeStatus = &activeStatus
	return r
}

// Comma delimited list of specific fields to be returned. Format: topLevelNode, childNode, attribute
func (r ApiGetAllBroadcastersRequest) Fields(fields interface{}) ApiGetAllBroadcastersRequest {
	r.fields = &fields
	return r
}

func (r ApiGetAllBroadcastersRequest) Execute() (*http.Response, error) {
	return r.ApiService.GetAllBroadcastersExecute(r)
}

/*
GetAllBroadcasters Get All Active Broadcasters

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiGetAllBroadcastersRequest
*/
func (a *BroadcastAPIService) GetAllBroadcasters(ctx context.Context) ApiGetAllBroadcastersRequest {
	return ApiGetAllBroadcastersRequest{
		ApiService: a,
		ctx: ctx,
	}
}

// Execute executes the request
func (a *BroadcastAPIService) GetAllBroadcastersExecute(r ApiGetAllBroadcastersRequest) (*http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "BroadcastAPIService.GetAllBroadcasters")
	if err != nil {
		return nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/api/v1/broadcasters"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	if r.activeStatus != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "activeStatus", r.activeStatus, "", "")
	}
	if r.fields != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "fields", r.fields, "", "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarHTTPResponse, newErr
	}

	return localVarHTTPResponse, nil
}

type ApiGetBroadcastsRequest struct {
	ctx context.Context
	ApiService *BroadcastAPIService
	broadcasterIds *interface{}
	fields *interface{}
}

// All of the broadcast details
func (r ApiGetBroadcastsRequest) BroadcasterIds(broadcasterIds interface{}) ApiGetBroadcastsRequest {
	r.broadcasterIds = &broadcasterIds
	return r
}

// Comma delimited list of specific fields to be returned. Format: topLevelNode, childNode, attribute
func (r ApiGetBroadcastsRequest) Fields(fields interface{}) ApiGetBroadcastsRequest {
	r.fields = &fields
	return r
}

func (r ApiGetBroadcastsRequest) Execute() (*http.Response, error) {
	return r.ApiService.GetBroadcastsExecute(r)
}

/*
GetBroadcasts Get Broadcasters

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiGetBroadcastsRequest
*/
func (a *BroadcastAPIService) GetBroadcasts(ctx context.Context) ApiGetBroadcastsRequest {
	return ApiGetBroadcastsRequest{
		ApiService: a,
		ctx: ctx,
	}
}

// Execute executes the request
func (a *BroadcastAPIService) GetBroadcastsExecute(r ApiGetBroadcastsRequest) (*http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "BroadcastAPIService.GetBroadcasts")
	if err != nil {
		return nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/api/v1/broadcast"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.broadcasterIds == nil {
		return nil, reportError("broadcasterIds is required and must be specified")
	}

	parameterAddToHeaderOrQuery(localVarQueryParams, "broadcasterIds", r.broadcasterIds, "", "")
	if r.fields != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "fields", r.fields, "", "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarHTTPResponse, newErr
	}

	return localVarHTTPResponse, nil
}
